/*
 * Copyright (C) 2023 niushuai233 niushuai.cc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package cc.niushuai.gasweb.entity;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * 气体数据表
 *
 * @author niushuai233
 * @date 2024/6/7 10:35
 * @since 0.0.1
 */
@Data
@Entity
@Table(name = "gas")
@Schema(title = "Gas气体实体类")
public class Gas {

    @Id
    @Schema(title = "id")
    private Long id;

    /**
     * 记录时间
     */
    @Schema(title = "记录时间")
    @Column(name = "time")
    private Date time;

    /**
     * 一氧化碳气体
     */
    @Schema(title = "一氧化碳浓度")
    @Column(name = "co")
    private String co;

    /**
     * 二氧化碳气体
     */
    @Schema(title = "二氧化碳浓度")
    @Column(name = "co2")
    private String co2;

    /**
     * 甲烷气体
     */
    @Schema(title = "甲烷浓度")
    @Column(name = "ch4")
    private String ch4;

    /**
     * 温度 摄氏度
     */
    @Schema(title = "温度 摄氏度")
    @Column(name = "temperature")
    private String temperature;

    /**
     * rp2040 温度
     */
    @Schema(title = "rp2040温度 摄氏度")
    @Column(name = "rp2040_temperature")
    private String rp2040Temperature;
}
