/*
 * Copyright (C) 2023 niushuai233 niushuai.cc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package cc.niushuai.gasweb.repository;

import cc.niushuai.gasweb.entity.CH2O;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * ch2o sql repository
 *
 * @author niushuai233
 * @date 2024/11/18 15:47
 * @since 0.0.1
 */
@Repository
public interface CH2ORepository extends JpaRepository<CH2O, Long> {

    List<CH2O> findAllByTimeBetweenOrderByIdAsc(Date startDateTime, Date endDateTime);

}
