<!DOCTYPE html>
<html lang="en">
<head>
    <title>Gas Web Application</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <#--bootstrap-->
    <link rel="stylesheet" href="${request.contextPath}/bootstrap-3.4.1/bootstrap.min.css"/>

    <#--datepicker-->
    <link rel="stylesheet" href="${request.contextPath}/datepicker/datepicker.css"/>


    <style>
        .container {
            width: 85%;
        }

        .charts {
            height: 400px;
        }

        .J-datepicker-range {
        }
    </style>
</head>
<body>

<div class="container">
    <div class="row">
        <h2>Gas监控</h2>
        <div class="c-datepicker-date-editor J-datepicker-range">
            <i class="c-datepicker-range__icon kxiconfont icon-clock"></i>
            <input autocomplete="off" placeholder="开始日期" id="startDateTime" name="" class="c-datepicker-data-input"
                   value="">
            <span class="c-datepicker-range-separator">-</span>
            <input autocomplete="off" placeholder="结束日期" id="endDateTime" name="" class="c-datepicker-data-input"
                   value="">
        </div>
    </div>
    <br/><br/><br/>
    <div class="row">
        <div class="col-xs-12 col-md-4">
            <div id="coDiv" class="charts"></div>
        </div>
        <div class="col-xs-12 col-md-4">
            <div id="co2Div" class="charts"></div>
        </div>
        <div class="col-xs-12 col-md-4">
            <div id="ch4Div" class="charts"></div>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12 col-md-6">
            <div id="tempDiv" class="charts"></div>
        </div>
        <div class="col-xs-12 col-md-6">
            <div id="rp2040_tempDiv" class="charts"></div>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12 col-md-6">
            <div id="ch2oDiv" class="charts"></div>
        </div>
    </div>
</div>
</body>
<#--jq-->
<script src="${request.contextPath}/jquery-3.7.1/jquery.min.js"></script>
<#--bootstrap-->
<script src="${request.contextPath}/bootstrap-3.4.1/bootstrap.min.js"></script>
<#--datepicker-->
<script src="${request.contextPath}/datepicker/moment.min.js"></script>
<script src="${request.contextPath}/datepicker/datepicker.all.min.js"></script>
<script src="${request.contextPath}/datepicker/datepicker.en.js"></script>
<#--echarts-->
<script src="${request.contextPath}/echarts/echarts.min.js"></script>

<script src="${request.contextPath}/index/main.js"></script>
<script src="${request.contextPath}/chart/options.js"></script>
<script>
    let contextPath = "${request.contextPath}/";

    let startDateTime = moment().subtract(1800, 'seconds').format("YYYY-MM-DD HH:mm:ss");
    $("#startDateTime").val(startDateTime);
    let endDateTime = moment().format("YYYY-MM-DD HH:mm:ss");
    $("#endDateTime").val(endDateTime);


    // 基于准备好的dom，初始化echarts实例
    var coChart = echarts.init(document.getElementById('coDiv'));
    var co2Chart = echarts.init(document.getElementById('co2Div'));
    var ch4Chart = echarts.init(document.getElementById('ch4Div'));
    var tempChart = echarts.init(document.getElementById('tempDiv'));
    var rp2040_tempChart = echarts.init(document.getElementById('rp2040_tempDiv'));
    var ch2oChart = echarts.init(document.getElementById('ch2oDiv'));


    // 使用刚指定的配置项和数据显示图表。
    coChart.setOption(getOption('CO浓度', ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'], [820, 932, 901, 934, 1290, 1330, 1320], 'ppm'));
    co2Chart.setOption(getOption('CO2浓度', ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'], [820, 932, 901, 934, 1290, 1330, 1320], 'ppm'));
    ch4Chart.setOption(getOption('CH4浓度', ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'], [820, 932, 901, 934, 1290, 1330, 1320], 'ppm'));
    tempChart.setOption(getOption('环境温度', ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'], [820, 932, 901, 934, 1290, 1330, 1320], '°C'));
    rp2040_tempChart.setOption(getOption('rp2040温度', ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'], [820, 932, 901, 934, 1290, 1330, 1320], 'ppm'));
    ch2oChart.setOption(getOption('CH2O浓度', ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'], [820, 932, 901, 934, 1290, 1330, 1320], 'ppb'));

    window.addEventListener('resize', function () {
        coChart.resize();
        co2Chart.resize();
        ch4Chart.resize();
        tempChart.resize();
        rp2040_tempChart.resize();
        ch2oChart.resize();
    });


    function refreshChartDate() {

        $.post(contextPath + "chart/fetch", {
            "startDateTime": startDateTime,
            "endDateTime": endDateTime
        }, function (data) {
            if (data) {
                rebuildChart(coChart, data.co, 'ppm');
                rebuildChart(co2Chart, data.co2, 'ppm');
                rebuildChart(ch4Chart, data.ch4, 'ppm');
                rebuildChart(tempChart, data.temperature, '°C');
                rebuildChart(rp2040_tempChart, data.rp2024_temperature, '°C');
                rebuildChart(ch2oChart, data.ch2o, 'ppb');
            }
        });
    }

    $(function () {

        var DATAPICKERAPI = {
            // 填充当前月默认值函数
            activeMonthRange: function () {
                return {
                    begin: moment().set({'date': 1, 'hour': 0, 'minute': 0, 'second': 0}).format('YYYY-MM-DD HH:mm:ss'),
                    end: moment().set({'hour': 23, 'minute': 59, 'second': 59}).format('YYYY-MM-DD HH:mm:ss')
                }
            },

            // 新增帮助生成近n小时快捷选项值
            shortcutPrevHours: function (hour) {
                var nowDay = moment().get('date');
                var prevHours = moment().subtract(hour, 'hours');
                var prevDate = prevHours.get('date') - nowDay;
                var nowTime = moment().format('HH:mm:ss');
                var prevTime = prevHours.format('HH:mm:ss');
                return {
                    day: prevDate + ',0',
                    time: prevTime + ',' + nowTime,
                    name: '最近' + hour + '小时'
                }
            },
            // 帮助生成当月快捷选项值
            shortcutMonth: function () {
                // 当月
                var nowDay = moment().get('date');
                var prevMonthFirstDay = moment().subtract(1, 'months').set({'date': 1});
                var prevMonthDay = moment().diff(prevMonthFirstDay, 'days');
                return {
                    now: '-' + nowDay + ',0',
                    prev: '-' + prevMonthDay + ',-' + nowDay
                }
            },
            // 注意为函数：快捷选项option:只能同一个月份内的
            rangeMonthShortcutOption1: function () {
                var result = DATAPICKERAPI.shortcutMonth();
                // 近18小时
                var resultTime1 = DATAPICKERAPI.shortcutPrevHours(1);
                var resultTime2 = DATAPICKERAPI.shortcutPrevHours(2);
                var resultTime12 = DATAPICKERAPI.shortcutPrevHours(12);
                return [
                    // 近n小时
                    {
                        name: resultTime1.name,
                        day: resultTime1.day,
                        time: resultTime1.time
                    }, {
                        name: resultTime2.name,
                        day: resultTime2.day,
                        time: resultTime2.time
                    }, {
                        name: resultTime12.name,
                        day: resultTime12.day,
                        time: resultTime12.time
                    }, {
                        name: '今天',
                        day: '-0,-0',
                        time: '00:00:00,23:59:59'
                    }, {
                        name: '昨天',
                        day: '-1,-1',
                        time: '00:00:00,23:59:59'
                    }, {
                        name: '最近一周',
                        day: '-7,0'
                    }, {
                        name: '最近一个月',
                        day: '-30,0'
                    }];
            },
        };

        $('.J-datepicker-range').datePicker({
            hasShortcut: true,
            isRange: true,
            format: 'YYYY-MM-DD HH:mm:ss',
            shortcutOptions: DATAPICKERAPI.rangeMonthShortcutOption1(),
            hide: function (type) {
                console.info('type：', type)
                if (type == 'confirm' || type == 'shortcut') {

                    startDateTime = $("#startDateTime").val();
                    endDateTime = $("#endDateTime").val();

                    console.info(startDateTime, endDateTime);

                    refreshChartDate();
                } else {
                    console.log("should be attach?");
                }
            }
        });

        //时分秒年月日范围，包含最大最小值
        // $('.J-datepicker-range').datePicker({
        //     hasShortcut: true,
        //     isRange: true,
        //     format:'YYYY-MM-DD HH:mm:ss',
        //     shortcutOptions: [{
        //         name: '今天',
        //         day: '-0,-0',
        //         time: '00:00:00,23:59:59'
        //     }, {
        //         name: '昨天',
        //         day: '-1,-1',
        //         time: '00:00:00,23:59:59'
        //     }, {
        //         name: '最近一周',
        //         day: '-7,0',
        //         time: '00:00:00,'
        //     }, {
        //         name: '最近一个月',
        //         day: '-30,0',
        //         time: '00:00:00,'
        //     }, {
        //         name: '最近三个月',
        //         day: '-90, 0',
        //         time: '00:00:00,'
        //     }],
        //     hide: function (type) {
        //         console.info('type：', type)
        //         if (type == 'confirm' || type == 'shortcut') {
        //
        //             startDateTime = $("#startDateTime").val();
        //             endDateTime = $("#endDateTime").val();
        //
        //             console.info(startDateTime, endDateTime);
        //
        //             refreshChartDate();
        //         } else {
        //             console.log("should be attach?");
        //         }
        //     }
        // });


        refreshChartDate();
    })
</script>
</html>

